/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQOBJECT_H__
#define __SQOBJECT_H__

#include "sqobjectinfo.h"
#include <vector>
#include <string>

namespace sqobject {

/**
 * IuWFNgp
 */
class Object {

protected:
	// ̃IuWFNg҂ĂXbḧꗗ
	std::vector<Thread*> _waitThreadList;
	// delegate
	ObjectInfo delegate;

public:
	/**
	 * IuWFNg҂̓o^
	 * @param thread Xbh
	 */
	void addWait(Thread *thread);
	
	/**
	 * IuWFNg҂̉
	 * @param thread Xbh
	 */
	void removeWait(Thread *thread);

	/**
	 * RXgN^
	 */
	Object();

	/**
	 * fXgN^
	 */
	virtual ~Object();

public:
	
	// ------------------------------------------------------------------

	/**
	 * ̃IuWFNg҂ĂPXbh̑҂
	 */
	void notify();
	
	/**
	 * ̃IuWFNg҂ĂSXbh̑҂
	 */
	void notifyAll();
	
	/**
	 * vpeBl擾
	 * @param name vpeB
	 * @return vpeBl
	 */
	SQRESULT _get(HSQUIRRELVM v);

	/**
	 * vpeBɒlݒ
	 * @param name vpeB
	 * @param value vpeBl
	 */
	SQRESULT _set(HSQUIRRELVM v);

	/**
	 * setvpeB̑݊mF
	 * @param name vpeB
	 * @return setvpeB݂ true
	 */
	SQRESULT hasSetProp(HSQUIRRELVM v);
	
	/**
	 * Ϗ̐ݒ
	 */
	SQRESULT setDelegate(HSQUIRRELVM v);

	/**
	 * Ϗ̎擾
	 */
	SQRESULT getDelegate(HSQUIRRELVM v);

	// ------------------------------------------------------------------
	//
	// sqplus o^p
	//
	// ------------------------------------------------------------------

public:
	/**
	 * squirrel RXgN^
	 */
	static SQRESULT constructor(HSQUIRRELVM v);

	/**
	 * squirrel [Xp
	 */
	SQ_DECLARE_RELEASE(Object);

public:
	/**
	 * squirrel NXo^
	 */
	static void registClass();
};

};// namespace

// NXo^p}N
#define SQCLASS(Class)	SqPlus::SQClassDef<Class> cls(_SC(#Class))
#define SQCLASS2(Class,Base)	SqPlus::SQClassDef<Class,Base> cls(_SC(#Class))
#define SQSFUNC(Class, Name) cls.staticFunc(&Class::Name,_SC(#Name))
#define SQSVFUNC(Class, Name) cls.staticFuncVarArgs(&Class::Name,_SC(#Name))
#define SQFUNC(Class, Name) cls.func(&Class::Name,_SC(#Name))
#define SQVFUNC(Class, Name) cls.funcVarArgs(&Class::Name,_SC(#Name))
#define SQENUM(Name, Value) cls.enumInt(Value, _SC(#Name))

// Oo͗p
#define PRINT(v,msg) {\
	SQPRINTFUNCTION print = sq_getprintfunc(v);\
	if (print) {\
		print(v,msg);\
	}\
}

#endif
