/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */

#ifndef __SQOBJECTINFO_H__
#define __SQOBJECTINFO_H__

#include <squirrel.h>
#include <sqplus.h>

namespace sqobject {

class Object;
class Thread;
	
// ---------------------------------------------------------
// ObjectInfo
// ---------------------------------------------------------

/**
 * squirrel IuWFNgێpNX
 */
class ObjectInfo {

protected:
	HSQUIRRELVM v; // IuWFNg̑ĂVM
	HSQOBJECT obj; // IuWFNgQƏ

public:
	// e
	void clear();

	// X^bN擾
	void getStack(HSQUIRRELVM v, int idx);

	// RXgN^
	ObjectInfo();

	// RXgN^
	ObjectInfo(HSQUIRRELVM v, int idx);

	// Rs[RXgN^
	ObjectInfo(const ObjectInfo &orig);

	// 
	ObjectInfo & operator=(const ObjectInfo &orig);

	// fXgN^
	virtual ~ObjectInfo();

	// XbhH
	bool isThread() const;

	// XbhH
	bool isSameThread(const HSQUIRRELVM v) const;

	// Xbh擾
	operator HSQUIRRELVM() const;
	
	// IuWFNgPUSH
	void push(HSQUIRRELVM v) const;

	// ---------------------------------------------------
	// delegate p
	// ---------------------------------------------------

	// delegate Ƃċ@\邩ǂ
	bool isDelegate();

	// bindenv 邩ǂ
	bool isBindDelegate();

	// ---------------------------------------------------
	// IuWFNg擾
	// ---------------------------------------------------

	// CX^X[U|C^擾
	Thread *getThread();

	// CX^X[U|C^擾
	Object *getObject();
	
	// ---------------------------------------------------
	// waitp\bh
	// ---------------------------------------------------

	bool isSameString(const SQChar *str) const;
};

};

#endif
